# Copyright (C) 1999 by Juergen Pfeifer
# Ada for Linux Team (ALT)
#
# Permission is hereby granted, free of charge, to any person obtaining a  
# copy of this software and associated documentation files (the            
# "Software"), to deal in the Software without restriction, including      
# without limitation the rights to use, copy, modify, merge, publish,      
# distribute, distribute with modifications, sublicense, and/or sell       
# copies of the Software, and to permit persons to whom the Software is    
# furnished to do so, subject to the following conditions:                 
#                                                                          
# The above copyright notice and this permission notice shall be included  
# in all copies or substantial portions of the Software.                   
#                                                                          
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS  
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF               
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.   
# IN NO EVENT SHALL THE ABOVE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,   
# DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR    
# OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR    
# THE USE OR OTHER DEALINGS IN THE SOFTWARE.                               
#                                                                          
# Except as contained in this notice, the name(s) of the above copyright   
# holders shall not be used in advertising or otherwise to promote the     
# sale, use or other dealings in this Software without prior written       
# authorization.          
#
# ---------------------------------------------------------------------------
#  Author: Jrgen Pfeifer <Juergen.Pfeifer@T-Online.de>
# ---------------------------------------------------------------------------
#
# GNU Ada RPM Packaging for GNU plotutils
#
%define        GNAT_TARGET_ARCH    i386
%define        COMPAT_TARGET_ARCH  i386 i486 i586 i686
%define        GNAT_TARGET_OS      Linux
%define        TARGET_OS           linux 
#
%define        BASE_NAME           gnat
%define        GNAT_PKG_NAME       gnat-3.11p
%define        GNAT_VERSION        3.11p
%define        GNAT_PKG_VERSION    1
%define        GNAT_PKG_RELEASE    10
%define        GCC_VERSION         2.8.1
%define        GDB_VERSION         4.17
#
%define        DEF_USER       bin
%define        DEF_GROUP      bin
#
%define        BASE_VERSION   gcc-%{GCC_VERSION}
#
%define        CFG_PREFIX     /usr
%define        ADA_ROOT       /lib/gnat
%define        ADA_BASE       %{CFG_PREFIX}%{ADA_ROOT}
#
%define        GNAT_SO_MAJOR  %{GNAT_PKG_VERSION}
%define        GNAT_SO_MINOR  %{GNAT_PKG_RELEASE}
#
%define        RPM_C_FLAGS     -O3 -m486 -fomit-frame-pointer
%define        RPM_ADA_FLAGS   -gnatpn
#
%define        THREADLIBS     -lpthread
#
%define        GNAT_NAME      gnat-%{GNAT_VERSION}
%define        GNAT_SO        %{GNAT_NAME}
%define        GNAT_DIR       %{ADA_BASE}/%{GNAT_NAME}
#
%define        AINC_NAME      adainclude
%define        AINC_DIR       %{ADA_BASE}/%{AINC_NAME}
#
%define        ALIB_NAME      adalib
%define        ALIB_DIR       %{ADA_BASE}/%{ALIB_NAME}
#
%define        ETC_NAME       etc
%define        ETC_DIR        %{ADA_BASE}/%{ETC_NAME}
#
%define        COMPAT_NAME    act_compat-%{GNAT_VERSION}
%define        COMPAT_DIR     %{ADA_BASE}/%{COMPAT_NAME}
#
%define        ASIS_NAME      asis-%{GNAT_VERSION}
%define        ASIS_SO        %{ASIS_NAME}
%define        ASIS_DIR       %{ADA_BASE}/%{ASIS_NAME}
#
%define        GLADE_NAME     glade-%{GNAT_VERSION}
%define        GLADE_DIR      %{ADA_BASE}/%{GLADE_NAME}
#dnl
#
%define        PKG_NAME       adaplotutils
%define        PKG_VERSION    2.0
%define        PKG_RELEASE    1
#
# ---------------------------------------------------------------------------
# We restrict the use of this package scipt at the moment to Intel and Linux.
# For sure there are details (compiler options, shared library building)
# that must be fixed for other architectures and OSes.
#
ExclusiveArch: %{COMPAT_TARGET_ARCH}
ExclusiveOS:   %{GNAT_TARGET_OS}
Packager:      Jrgen Pfeifer <Juergen.Pfeifer@t-online.de>
Distribution:  ALT (Ada for Linux Team)
Version:       %{PKG_VERSION}
Release:       %{PKG_RELEASE}
Name:          %{PKG_NAME}
BuildRoot:     /var/tmp/%{PKG_NAME}-%{version}-root
Autoreq:       No
Autoreqprov:   No
# ---------------------------------------------------------------------------
# This are the official sources
Source0:       ada-plotutil-%{PKG_VERSION}.tar.gz
Source1:       gnu-plotutils.spec
#
#  ---------------------------------------------------------------------------
Copyright:     BSD like
Summary:       Ada95 binding for the GNU plotutils library
Summary(de):   Ada95 Binding fr die GNU plotutils Bibliothek
Group:         Libraries
Requires:      %{GNAT_PKG_NAME}-devel >= %{GNAT_PKG_VERSION}-10
Requires:      plotutils >= 2.2
Obsoletes:     %{name}
Icon:          adasmall.gif
Prefix:        %{CFG_PREFIX}
#
%description
This is a set of Ada95 packages that allows you to use the GNU
plotutils library. This library contains a rather complete set
of plotting functions for a variety of graphical devices.
#
%description -l de
Dies ist eine Sammlung von Ada95 Paketen, die es Ihnen erlaubt,
die GNU plotutils Bibliothek zu benutzen. Diese Bibliothek enthlt
eine recht vollstndige Sammlung von Zeichen-Funktioen fr eine
Reihe von Grafik-Gerten.
#
#-----------------------------------------------------------------------------
%prep
#=============================================================================
#
%setup -c -q
#
#-----------------------------------------------------------------------------
%build
#=============================================================================
# Create the required directory structure for the binary package
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{AINC_DIR}
mkdir -p $RPM_BUILD_ROOT%{ALIB_DIR}
mkdir -p $RPM_BUILD_ROOT/doc
mkdir -p $RPM_BUILD_ROOT/usr/doc
#
cd ada-plotutil-%{PKG_VERSION}
rm -f include/gnu.ads
make CFLAGS="%{RPM_C_FLAGS} %{RPM_ADA_FLAGS}"
#
#-----------------------------------------------------------------------------
%install
#=============================================================================
OS=%{TARGET_OS}
#
cd ada-plotutil-%{PKG_VERSION}
#
cp -pf  include/gnu-*.ad? $RPM_BUILD_ROOT%{AINC_DIR}
cp -pf  objects/gnu-*.ali $RPM_BUILD_ROOT%{ALIB_DIR}
cp -pf  objects/*.a       $RPM_BUILD_ROOT%{ALIB_DIR}
#
cp -pf  README     $RPM_BUILD_ROOT/doc
cp -pf  COPYRIGHT  $RPM_BUILD_ROOT/doc
cp -pf  NEWS       $RPM_BUILD_ROOT/doc
#
cp -pf  $RPM_SOURCE_DIR/gnu-plotutils.spec $RPM_BUILD_ROOT/doc
cat > $RPM_BUILD_ROOT/doc/README.plotutils <<EOF
The GNU Ada95 binding to plotutils requires that you have plotutils
installed as RPM package. For your conveniance we provide the spec
file for the most current version in this documentation directory.
You have to do the followin steps:

  1. Copy gnu-plotutils.spec to /usr/src/redhat/SPECS
  2. Edit /usr/src/redhat/SPECS/gnu-plotutils.spec. You must delete the
     --with-motif clause if you don't want to use Motif.
  3. Get the tar file from the GNU site or a mirror that is mentioned in
     the Source: tag and copy it into the /usr/src/redhat/SOURCES directory.
  4. Type this command:
           rpm -ba --clean gnu-plotutils.spec
  5. If everything worked you'll find the plotutils package in the
     /usr/src/redhat/RPMS/i386 directory.

EOF
#
find samples -name '*.ad?' -print |\
	cpio -pdmuv $RPM_BUILD_ROOT/doc
#
for f in `find samples -name 'Makefile' -print`
do
   mv $f $f.tmp
   sed -e "s:DIRS=.*:DIRS=:g" < $f.tmp > $f	  
done
#
find samples -name 'Makefile' -print |\
	cpio -pdmuv $RPM_BUILD_ROOT/doc
rm -f $RPM_BUILD_ROOT/doc/samples/use_all*
#
#
if [ -d ${RPM_BUILD_ROOT}%{AINC_DIR} ]; then
  find ${RPM_BUILD_ROOT}%{AINC_DIR} -type f -name '*.ad?' -exec chmod 0444 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}%{ALIB_DIR} ]; then
  find ${RPM_BUILD_ROOT}%{ALIB_DIR} -type f -name '*.ali' -exec chmod 0444 {} \;
  find ${RPM_BUILD_ROOT}%{ALIB_DIR} -type f -name '*.a'   -exec chmod 0444 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}%{CFG_PREFIX}/lib ]; then
  find ${RPM_BUILD_ROOT}%{CFG_PREFIX}/lib -type f -name '*.so*' -exec chmod 0755 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}/doc ]; then
  find ${RPM_BUILD_ROOT}/doc -type f -exec chmod 0444 {} \;
  find ${RPM_BUILD_ROOT}/doc -type d -exec chmod 0755 {} \;
fi
#  ---------------------------------------------------------------------------
%pre
if [ -f /etc/profile.d/%{BASE_NAME}-rts.sh ]; then
  source /etc/profile.d/%{BASE_NAME}-rts.sh
  if [ ! -z ${GNAT_ROOT} ]; then
    if [ "${GNAT_ROOT}" != "${RPM_INSTALL_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed with --prefix=${GNAT_ROOT}" >&2
      echo "You must use the same prefix with this package." >&2
      exit 1
    fi
  else
    if [ "${RPM_INSTALL_PREFIX}" != "%{CFG_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed without the --prefix option." >&2
      echo "You must do this also with this package." >&2
      exit 1
    fi
  fi
fi
#  ---------------------------------------------------------------------------
%files
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%doc $RPM_BUILD_ROOT/doc/*
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/doc
%dir %{ADA_BASE}
%dir %{AINC_DIR}
%dir %{ALIB_DIR}
%{AINC_DIR}/*
%{ALIB_DIR}/*
#
#  ---------------------------------------------------------------------------
%clean
rm -rf $RPM_BUILD_ROOT
#
#  ---------------------------------------------------------------------------
%changelog
* Sat Mar 13 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Published as Release 1

* Wed Mar 10 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Created
